#TEMPLATE(CreditCardChk,'Sterling Data')
#!
#!
#!   Release 1.0  
#!
#!   This Template is Copyright 1995 Sterling Data Services
#!   You may use it in your applications without charge - but you do so
#!   at your own risk!  No liabilities accepted.  No charge may be made
#!   for distributing this template.
#!
#!
#!   For help on using this or for details of my other templates I can be
#!   contacted on Compuserve 100010,1150 or Cargo BBS (UK)
#!
#!   Mike McLoughlin
#!
#CONTROL(CardChk,'Card No. Validation - freeware from Sterling Data'),WINDOW,MULTI
#BOXED('STERLING DATA - Credit Card Validation Template')
  #DISPLAY('')
  #PROMPT('Credit Card Field :',FROM(%Control)),%CCtrlName,REQ
  #DISPLAY('')
  #PROMPT('Message if Card Invalid :',@s50),%CcardMsg,DEFAULT('This credit card number is NOT valid')
  #DISPLAY('')
  #PROMPT('If Card Validates OK : ',OPTION),%CcOptSymbol
  #PROMPT('Do Nothing',RADIO)
  #PROMPT('Show OK Icon',RADIO)
  #PROMPT('Beep',RADIO)
  #DISPLAY('')
   #ENABLE(%ccOptSymbol='Show OK Icon')
     #PROMPT('Length of time to show Icon',@n_3),%CCIconTime,DEFAULT(100)
     #DISPLAY('In 100ths of a second')
   #ENDENABLE
  #DISPLAY('')
#ENDBOXED
  CONTROLS
    BUTTON('Validate'),AT(,,36,14)USE(?CardChkButton),MSG('Validate Credit Card Number')
    IMAGE('CARDOK.ICO'),AT(-30,,14,18),USE(?CCIcon),HIDE
  END
#LOCALDATA
Ccsum       SHORT
CcNumber    LONG
CcJ         BYTE
CCLength  SHORT
CreditCardChkSum    SHORT
CCtrlname   STRING(30)
CreditCardStr2   STRING(30)
CcardPos  BYTE
CcStrPos  BYTE
CcardQ  Queue
CcQSeq  BYTE
CcQByte BYTE
.
#ENDLOCALDATA
#ATSTART
    #DECLARE(%CcardControl)
    #DECLARE(%CtrlUse)
    #FOR(%Control),WHERE(%ControlInstance=%ActiveTemplateInstance)
      #SET(%CcardControl,%Control)
      #if(%CcardControl='?CCIcon')
        #CYCLE
      #ENDIF
      #BREAK
    #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%CcardControl,'Accepted')
! Sterling Data - Credit Card Check template
     Do CCardChecker
! End Template
#ENDAT
#AT(%ProcedureRoutines)
! Sterling Data - Credit Card Check template
CcardChecker    Routine
    #FIX(%Control,%CctrlName)
    #IF(%ControlUse=' ')
      #ERROR('A credit card field MUST be selected. Do Not Proceed. In the Screen Formatter Right-Click on the Validate Button and choose ACTIONS')
      #ABORT
    #ENDIF
    CcSum=0
    CreditCardStr2=%ControlUse  ! allow for number conversion
    CcardPos=1
    CcStrPos=1
    LOOP
      CCqByte=VAL(SUB(CreditCardStr2,CcStrPos,1))
      CcQSeq=CcardPos
      CcStrPos+=1
      IF CcStrPos > 30 THEN Break.
      IF CcQByte >= 48
        IF CcQByte <= 57  ! Check if a before adding
          ADD(CcardQ,CcQSeq)
          CcardPos+=1
          IF CcardPos > 30 THEN break.
        .
      .
    .
    cclength = CcardPos-1

    LOOP CcJ=1 to cclength
     CcQSeq=CcJ
     GET(CcardQ,CcQSeq)
     Ccnumber=CcqByte
     Ccnumber=BAND(Ccnumber,0Fh)

     if ((cclength - (CcJ-1)) % 2) = 0
        Ccnumber =Ccnumber* 2
        if Ccnumber > 9 THEN CCnumber -= 9.
     .
     Ccsum += Ccnumber
     .

    CreditCardChkSum=CcSum % 10
    if CreditCardChkSum > 0
      ccjk#=Message('%CcardMsg','WARNING',ICON:hand)
     else
       #IF(%CCOptSymbol='Show OK Icon')
          UNHIDE(?CCIcon)
          DISPLAY(?CCIcon)
          ccicoticks#=clock();loop until clock()-ccicoticks#> %ccIconTime.
          HIDE(?CcIcon)
       #ENDIF
       #IF(%ccOptSymbol='Beep')
           beep(-1)
       #ENDIF
    .
    FREE(CcardQ)
    EXIT
! End Template
#ENDAT